
#include <cstring>
#include <ctime>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

//#include <glibmm/init.h>

#include "logger.h"

namespace AuthN {

  inline std::string toString(logLevel level) {
    static const char* const buffer[] = {"FATAL", "ERROR", "WARNING", "INFO", "VERBOSE", "DEBUG"};
    return buffer[level];
  }

  inline std::string NowTime() {
    char buffer[11];
    time_t t;
    time(&t);
    tm r = {0};
    strftime(buffer, sizeof(buffer), "%X", localtime_r(&t, &r));
    return buffer;
  }

  Logger::Logger(std::ostream &out, logLevel level)
  : out_(out),
    level_(level) {
  }
/*
  void Logger::msg(logLevel level, const char *message) {
    Glib::Mutex::Lock lock(mutex_);

    if (level <= level_) {
      out_ << "[" <<NowTime() << "] [" << toString(level) << "] " <<message;
      if (message[strlen(message)] != '\n')
        out_ << '\n';
    }
    out_.flush();
  }
*/

  int Logger::msg(logLevel level, const char *format, ...) {
//    Glib::Mutex::Lock lock(mutex_);
    char buf[1024];
    va_list args;
    int retval;

    va_start (args, format);
    retval = vsprintf (buf, format, args);

    if (level <= level_) {
      out_ << "[" <<NowTime() << "] [" << toString(level) << "] " <<buf;
      if (buf[strlen(buf)] != '\n')
        out_ << '\n';
    }
    out_.flush();

    va_end (args);
    return retval;
  }

  void Logger::msg(logLevel level, std::string message) {
    msg(level, "%s", message.c_str());
  }

  void Logger::setlevel(logLevel level) {
//    Glib::Mutex::Lock lock(mutex_);
    level_ = level;
  }

  Logger& log(logLevel level, std::ostream &out) {
    static bool firstTime = true;
    static Logger* l;

    if (firstTime) {
      firstTime = false;
//      Glib::init();
      l = new Logger(out, level);
    }
    return *l;
  }

}
