#ifndef LOG_H_
#define LOG_H_

#include <iostream>
#include <string>
//#include <glibmm/thread.h>

namespace AuthN {

  typedef enum {
     FATAL,
     ERROR,
     WARNING,
     INFO,
     VERBOSE,
     DEBUG,
  } logLevel;

  class Logger;

  Logger& log(logLevel level=DEBUG, std::ostream &out=std::cerr);

  class Logger{
    friend Logger& log(logLevel, std::ostream&);

//    Glib::Mutex mutex_;
    std::ostream &out_;
    logLevel level_;
    Logger(std::ostream &out, logLevel level=ERROR);

  public:
    //void msg(logLevel level, const char *message);
    void msg(logLevel level, std::string message);
    int msg(logLevel level, const char *format, ...)
      __attribute__((__format__(__printf__, 3, 4)));
    void setlevel(logLevel level);
  };
  
}

#endif
