#include <iostream>
#include <string>
#include <list>

#include <openssl/ssl.h>

namespace AuthN {
  /*The implementation is according to the namespaces 
    format specification defined by eugridpma, see:
    http://www.eugridpma.org/documentation/eugridpma-namespaces-format-spec-20060113-0-1-4.pdf
   */
  class NamespacesPolicy {
  public:
    NamespacesPolicy(const X509_NAME* issuer_subject,const std::string& ca_path,bool must = false);
    ~NamespacesPolicy();
    bool Match(const X509_NAME* subject);
    operator bool(void) { return (file_ != NULL); };
    bool operator!(void) { return (file_ == NULL); };
  private:
    std::string issuer_;
    std::istream* file_;
  };
}

