
#include <string>
#include <openssl/x509.h>
#include <openssl/rsa.h>

namespace AuthN {

  /**
   * Initializes pkcs11-helper library, and loads PKCS #11 provider.
   * @param provider   full path to the PKCS #11 provider (e.g. /usr/lib/opensc-pkcs11.so)
   */
  bool loadProvider(const std::string& provider);

  void unloadProvider(const std::string& provider);

  bool getCredential(const std::string& certname, X509** x509, RSA** rsa);
}
