
#include <string>
#include <iostream>
#include <openssl/x509.h>
#include <openssl/rsa.h>
#include <openssl/pem.h>
#include "../nssutil.h"

int main(void) {
  bool res;

  std::string configdir =  "/home/wzqiang/.mozilla/firefox/ruu1txci.default";
  res = AuthN::NSS::nssInit(configdir);

  std::string eec_certfile = "eec_cert.pem";
  std::string eec_keyfile = "eec_key.pem";
  std::string eec_keyname = "eeckey";
  std::string eec_certname = "eeccert";
  char* slotpw = "secretpw";
  bool ascii = true;
  char* trusts = "p,p,p";
  res = AuthN::NSS::nssImportCertAndPrivateKey(slotpw, eec_keyfile, eec_keyname, eec_certfile, eec_certname, trusts, ascii);

  char* eec_p12 = "eec.p12";
  char* p12pw = "secretpw";
  res = AuthN::NSS::nssOutputPKCS12(eec_certname, eec_p12, slotpw, p12pw);

  std::string proxy_csrfile = "proxy.csr";
  std::string proxy_keyname = "myproxykey";
  std::string dn = "CN=Test,OU=EMI,O=Grid";
  std::string proxy_privk_str;
  res = AuthN::NSS::nssGenerateCSR(proxy_keyname, dn, slotpw, proxy_csrfile, proxy_privk_str, ascii);

  std::string proxy_certfile = "myproxy.pem";
  std::string issuername = "eeccert";  
  //The name of the certificate imported in firefox is 
  //normally "Imported Certificate" by default, if name is not specified
  int duration = 12;
  char* passwd;
  res = AuthN::NSS::nssCreateCert(proxy_csrfile, issuername, passwd, duration, proxy_certfile, ascii);

  char* proxy_certname = "proxy";
  res = AuthN::NSS::nssImportCert(slotpw, proxy_certfile, proxy_certname, trusts, ascii);

  char* proxy_p12 = "proxy.p12";
  res = AuthN::NSS::nssOutputPKCS12(proxy_certname, proxy_p12, slotpw, p12pw);

  return 0;

}
